![total.js logo](http://www.totaljs.com/download/logo-black.png)

web framework for node.js
=========================

__total.js__ is the best ever web application framework for creating a rich web sites and web services. The framework has good documentation and contains many examples. Please support the framework on GitHub and other social networks.

> Current version (v1.0.2) is __stable version__.

```
$ npm install total.js
```

- [total.js homepage - www.totaljs.com](http://totaljs.com)
- [__Documentation__](http://docs.totaljs.com)
- [Discussion forum](https://groups.google.com/forum/#!forum/totaljs)
- [Changelog](https://github.com/totaljs/framework/blob/master/changes.txt)
- [__Roadmap__](https://github.com/totaljs/framework/issues/milestones?with_issues=no)

__Development__:

- [Download empty project](https://github.com/totaljs/framework/releases)
- [Download empty project (Visual Studio, WebMatrix / Windows)](https://github.com/totaljs/framework/releases)
- [__Documentation__: Website testing on the internet (tunnel between localhost and internet)](http://docs.totaljs.com/#ngrok)
- [__Documentation__: Publish a website - REVERSE PROXY](http://docs.totaljs.com/#publish)
- [__Documentation__: total.js for Sublime Text 2 Editor](http://docs.totaljs.com/#sublime)

__Interesting__:

- [Tutorial](http://docs.totaljs.com/tutorial/)
- [Download __total.js modules__](https://github.com/totaljs/modules/)
- Framework supports [NoSQL Embedded database](https://github.com/petersirka/nosql) for max. 20 000 documents per database

__Social networks__:

- [__Discussion forum__](https://groups.google.com/forum/#!forum/totaljs)
- [Follow total.js on GitHub](https://github.com/totaljs/framework)
- [Follow total.js on Twitter - __@totalframework__](https://twitter.com/totalframework)
- [Follow total.js on Facebook](https://www.facebook.com/totaljs.web.framework)
- [Follow total.js on Google Plus](https://plus.google.com/u/0/113175077493180148081/posts)

__Examples__:

- [Sushi website example](http://sushi.totaljs.com)
- [TODO list example](http://todo.totaljs.com)
- [More than 90 examples](https://github.com/totaljs/examples/tree)master/

__Modules__:

- [Online counter](https://github.com/totaljs/modules/tree/master/online)
- [FileServer](https://github.com/totaljs/modules/tree/master/fileserver)
- [FileCache](https://github.com/totaljs/modules/tree/master/filecache)
- [FileStorage](https://github.com/totaljs/modules/tree/master/filestorage)
- [Fulltext search engine](https://github.com/totaljs/modules/tree/master/fulltext)
- [Authorization](https://github.com/totaljs/modules/tree/master/authorization)
- [Session (in-memory, redis or memcached)](https://github.com/totaljs/modules/tree/master/session)
- [Login with Facebook](https://github.com/totaljs/modules/tree/master/facebook)
- [Less CSS - lesscss.org](https://github.com/totaljs/modules/tree/master/less)
- [SASS CSS - www.sass-lang.com](https://github.com/totaljs/modules/tree/master/sass)
- [Jade view engine](https://github.com/totaljs/modules/tree/master/jade)
- [doT view engine](https://github.com/totaljs/modules/tree/master/dot)
- [Live storage](https://github.com/totaljs/modules/tree/master/storage)
- [Markdown parser](https://github.com/totaljs/modules/tree/master/markdown)

__Other products__:

- [FileServer: storing of uploaded files](https://github.com/petersirka/fileserver)

Documentation
-------------
- [English documentation](http://docs.totaljs.com/)

Do not miss
-----------

- [node.js - FileStorage](https://github.com/petersirka/node-filestorage) - storing of uploaded files (tip for total.js)
- [node.js - Fulltext search](https://github.com/petersirka/node-fulltext) - fulltext search engine for web application (tip for total.js)
- [node.js - PayPal Express Checkout](https://github.com/petersirka/node-paypal-express-checkout) (tip for total.js)
- [node.js - Coucher](https://github.com/petersirka/node-couchdb) - CouchDB database provider (tip for total.js)
- [node.js - MongoLab provider](https://github.com/petersirka/node-mongolab) - MongoLab client (tip for total.js)
- [node.js - NoSQL embedded database](https://github.com/petersirka/nosql)
- [node.js - Backup / Restore](https://github.com/petersirka/node-backup) - Backup / Restore solution

__Client-side libraries__

- [jQuery two way bindings](https://github.com/petersirka/jquery.bindings)
- [jQuery templates - total.js templating](https://github.com/petersirka/jquery.templates)
- [jQuery file upload (+ drag&drop)](https://github.com/petersirka/jquery.upload)
- [total.js routing on client-side via HTML 5 history API](https://github.com/petersirka/total.js-clientside)

***

Videos on YouTube
-----------------

- VIDEO: [Why is node.js awesome? WebSocket + nginx + total.js + HTML + JavaScript ](http://www.youtube.com/watch?v=4Vrqx0UnpYk)
- VIDEO: [Node.js / total.js debugging of web applications](http://www.youtube.com/watch?v=4wLq_bJ_sfs)
- VIDEO: [total.js / node.js - balancing of requests](http://www.youtube.com/watch?v=1VOJ7cWoboo)
- VIDEO: [HTML 5 Server-Sent Events (JavaScript) via total.js & node.js](http://www.youtube.com/watch?v=XoWIv3xGxR4)
- VIDEO: [node.js / total.js - Live streaming via multipart/x-mixed-replace + CSS auto vendor prefix](http://www.youtube.com/watch?v=qZqO4c4Fw2k)
- VIDEO: [Deployment of total.js / node.js website on appfog.com (freehosting)](http://www.youtube.com/watch?v=kZvCCyR6iBI)
- VIDEO: [WebSocket (Real-time) HTML5 Chat in 5 minutes - node.js & total.js](http://www.youtube.com/watch?v=lW1vsKMUaKg)
- VIDEO: [total.js / web application framework for node.js](http://www.youtube.com/watch?v=3GMQJki82Lo)

***

* **NEW** Supports workers - [example: workers](https://github.com/totaljs/examples/tree/master/workers)
* **NEW** Supports versioning of static files - [example: static-version](https://github.com/totaljs/examples/tree/master/static-version)
* Supports redirects - [example: host redirect](https://github.com/totaljs/examples/tree/master/redirect-host)
* Supports restrictions - [example: restrictions](https://github.com/totaljs/examples/tree/master/framework-restrictions)
* Controller proxy - [example: proxy](https://github.com/totaljs/examples/tree/master/controller-proxy)
* Supports server sent events - [example: server sent events](https://github.com/totaljs/examples/tree/master/server-sent-events)
* Supports live streaming via multipart/x-mixed-replace - [example: live streaming](https://github.com/totaljs/examples/tree/master/live-streaming)
* Supports uploading via multipart/x-mixed-replace - [example: live uploading](https://github.com/totaljs/examples/tree/master/live-streaming-upload)
* Supports CSS auto vendor prefixes - [read the benefits](http://www.totaljs.com/benefits/)
* Supports Websocket (Standard - RFC 6455) - [example: websocket](https://github.com/totaljs/examples/tree/master/websocket)
* Async web framework - [example: async methods](https://github.com/totaljs/examples/tree/master/async)
* Simple view engine - [example: view engine](https://github.com/totaljs/examples/tree/master/views)
* Simple routing + support flags ['xhr', 'post', 'put', 'delete', 'logged', etc.] - [example: routing flags](https://github.com/totaljs/examples/tree/master/routing-flags)
* Simple cacheing - [example: http cache example](https://github.com/totaljs/examples/tree/master/cache-http), [total cache example](https://github.com/totaljs/examples/tree/master/cache-total)
* Simple directory structure (controllers, modules, public, logs, tmp, templates, views, resources)
* Simple code structure
* Simple error handling
* Simple cookie manipulation - [example: cookies](https://github.com/totaljs/examples/tree/master/cookies)
* Simple listing via templates - [example: listing via templates](https://github.com/totaljs/examples/tree/master/templating)
* XSS protection - [example: XSS](https://github.com/totaljs/examples/tree/master/framework-xss-protection)
* Share controller functions and models over the framework - [example: controller sharing](https://github.com/totaljs/examples/tree/master/controller-sharing)
* __Assertion Testing__ - [example: testing](https://github.com/totaljs/examples/tree/master/testing)
* Supports custom helpers - [example: custom helpers](https://github.com/totaljs/examples/tree/master/View-custom-helper)
* Supports routing to static file for dynamic creating static file - [example: routing](https://github.com/totaljs/examples/tree/master/routing)
* Supports controller sharing between other controllers - [example: controller sharing](https://github.com/totaljs/examples/tree/master/controller-sharing)
* Supports debug mode with custom settings without cache - [example: debug mode](https://github.com/totaljs/examples/tree/master/config-debug-release)
* Supports file upload - [example: file upload](https://github.com/totaljs/examples/tree/master/upload-multipart)
* Supports copy&paste custom code between projects - [example: framework-custom](https://github.com/totaljs/examples/tree/master/framework-custom)
* __Supports modules__ (module can create a route, view, template, resource, etc.) - [example: module](https://github.com/totaljs/examples/tree/master/framework-modules)
* __Supports inject config from URL__ - [example: config inject](https://github.com/totaljs/examples/tree/master/framework-inject-config)
* __Supports inject module from URL__ - [example: module inject](https://github.com/totaljs/examples/tree/master/framework-inject-module)
* __Supports inject controller from URL__ - [example: controller inject](https://github.com/totaljs/examples/tree/master/framework-inject-controller)
* __Supports inject definition from URL__ - [example: definition inject](https://github.com/totaljs/examples/tree/master/framework-inject-definition)
* Supports form data validation - [example: validation](https://github.com/totaljs/examples/tree/master/validation)
* Supports simple log writer - [example: logs](https://github.com/totaljs/examples/tree/master/logs)
* Supports simple restrictions - [example: restriction](https://github.com/totaljs/examples/tree/master/restrictions-ip)
* Supports serve static files and custom handling static files - [example: static-file-handling](https://github.com/totaljs/examples/tree/master/static-file-handling)
* __Supports streaming static files__ - implemented Accept-Ranges - [example: video-streaming](https://github.com/totaljs/examples/tree/master/video-streaming)
* Supports HTML minification
* Supports JavaScript compress
* Supports JavaScript dynamic compress in views - [example: dynamic JavaScript compress](https://github.com/totaljs/examples/tree/master/views-javascript-compress)
* Supports simple LESS CSS (with compress) - [example: LESS CSS](https://github.com/totaljs/examples/tree/master/css-less)
* Supports resources (for multilanguage pages) - [example: resources](https://github.com/totaljs/examples/tree/master/localization-resources)
* __Supports prefixes for mobile devices__ - [example: prefixes](https://github.com/totaljs/examples/tree/master/mobile)
* Supports SMTP mail sender (attachment, HTML, basic authentication) - [example: SMTP mail sender](https://github.com/totaljs/examples/tree/master/email-templating)
* Supports simple mail templating - [example: mail templating](https://github.com/totaljs/examples/tree/master/email-templating)
* Supports custom authorization - [example: authorization](https://github.com/totaljs/examples/tree/master/authorization)
* Supports basic access authentication - [example: basic access authentication](https://github.com/totaljs/examples/tree/master/authorization-www-basic)
* Supports simple image processing (resize, grayscale, etc.) via GraphicsMagick/ImageMagick - [example: image-resize](https://github.com/totaljs/examples/tree/master/image-resize)
* Easy adding dynamic META tags in views or controllers - [example: meta tags](https://github.com/totaljs/examples/tree/master/views-meta)
* Easy adding dynamic Settings in views or controllers - [example: view settings](https://github.com/totaljs/examples/tree/master/views-settings)
* Simple use paypal payment with [example: node-paypal project](https://github.com/petersirka/node-paypal) - [example: paypal](https://github.com/totaljs/examples/tree/master/paypal)
* Supports simple pagination builder - [example: pagination builder](https://github.com/totaljs/examples/tree/master/paging)
* Supports live usage information - [example: framework usage](https://github.com/totaljs/examples/tree/master/framework-usage)
* Supports dynamic stop server - [example: stop server](https://github.com/totaljs/examples/tree/master/framework-stop)
* About 9 000 lines of JavaScript code, all files have 270 kB
* __NO DEPENDENCIES *** NO DEPENDENCIES *** NO DEPENDENCIES__
* [More examples](https://github.com/totaljs/examples/tree)master/
* [Documentation](http://docs.totaljs.com/)
* __Supports internal NoSQL embedded database__ - [example: authorization](https://github.com/totaljs/examples/tree/master/authorization) or [example: contact form](https://github.com/totaljs/examples/tree/master/contact-form)

***

## Install total.js step by step

![total.js on NPM](https://nodei.co/npm/total.js.png?downloads=true)

```
$ sudo npm install -g total.js
```
```
$ mkdir mywebsite
$ cd mywebsite
$ total
```
```
$ node debugging

# OR

$ node index 8080
```
```
$ open http://127.0.0.1:8000
```

## Contact

Peter Sirka - <petersirka@gmail.com>